"""
    Freqtrade API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 2021.12-dev21
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ftclient.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from ftclient.exceptions import ApiAttributeError


def lazy_import():
    from ftclient.model.order_types import OrderTypes
    from ftclient.model.unfilled_timeout import UnfilledTimeout
    globals()['OrderTypes'] = OrderTypes
    globals()['UnfilledTimeout'] = UnfilledTimeout


class ShowConfig(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'version': (str,),  # noqa: E501
            'api_version': (float,),  # noqa: E501
            'dry_run': (bool,),  # noqa: E501
            'stake_currency': (str,),  # noqa: E501
            'stake_amount': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'stake_currency_decimals': (int,),  # noqa: E501
            'max_open_trades': (int,),  # noqa: E501
            'minimal_roi': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'unfilledtimeout': (UnfilledTimeout,),  # noqa: E501
            'timeframe_ms': (int,),  # noqa: E501
            'timeframe_min': (int,),  # noqa: E501
            'exchange': (str,),  # noqa: E501
            'forcebuy_enabled': (bool,),  # noqa: E501
            'ask_strategy': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'bid_strategy': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'bot_name': (str,),  # noqa: E501
            'state': (str,),  # noqa: E501
            'runmode': (str,),  # noqa: E501
            'strategy_version': (str,),  # noqa: E501
            'available_capital': (float,),  # noqa: E501
            'stoploss': (float,),  # noqa: E501
            'trailing_stop': (bool,),  # noqa: E501
            'trailing_stop_positive': (float,),  # noqa: E501
            'trailing_stop_positive_offset': (float,),  # noqa: E501
            'trailing_only_offset_is_reached': (bool,),  # noqa: E501
            'order_types': (OrderTypes,),  # noqa: E501
            'use_custom_stoploss': (bool,),  # noqa: E501
            'timeframe': (str,),  # noqa: E501
            'strategy': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'version': 'version',  # noqa: E501
        'api_version': 'api_version',  # noqa: E501
        'dry_run': 'dry_run',  # noqa: E501
        'stake_currency': 'stake_currency',  # noqa: E501
        'stake_amount': 'stake_amount',  # noqa: E501
        'stake_currency_decimals': 'stake_currency_decimals',  # noqa: E501
        'max_open_trades': 'max_open_trades',  # noqa: E501
        'minimal_roi': 'minimal_roi',  # noqa: E501
        'unfilledtimeout': 'unfilledtimeout',  # noqa: E501
        'timeframe_ms': 'timeframe_ms',  # noqa: E501
        'timeframe_min': 'timeframe_min',  # noqa: E501
        'exchange': 'exchange',  # noqa: E501
        'forcebuy_enabled': 'forcebuy_enabled',  # noqa: E501
        'ask_strategy': 'ask_strategy',  # noqa: E501
        'bid_strategy': 'bid_strategy',  # noqa: E501
        'bot_name': 'bot_name',  # noqa: E501
        'state': 'state',  # noqa: E501
        'runmode': 'runmode',  # noqa: E501
        'strategy_version': 'strategy_version',  # noqa: E501
        'available_capital': 'available_capital',  # noqa: E501
        'stoploss': 'stoploss',  # noqa: E501
        'trailing_stop': 'trailing_stop',  # noqa: E501
        'trailing_stop_positive': 'trailing_stop_positive',  # noqa: E501
        'trailing_stop_positive_offset': 'trailing_stop_positive_offset',  # noqa: E501
        'trailing_only_offset_is_reached': 'trailing_only_offset_is_reached',  # noqa: E501
        'order_types': 'order_types',  # noqa: E501
        'use_custom_stoploss': 'use_custom_stoploss',  # noqa: E501
        'timeframe': 'timeframe',  # noqa: E501
        'strategy': 'strategy',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, version, api_version, dry_run, stake_currency, stake_amount, stake_currency_decimals, max_open_trades, minimal_roi, unfilledtimeout, timeframe_ms, timeframe_min, exchange, forcebuy_enabled, ask_strategy, bid_strategy, bot_name, state, runmode, *args, **kwargs):  # noqa: E501
        """ShowConfig - a model defined in OpenAPI

        Args:
            version (str):
            api_version (float):
            dry_run (bool):
            stake_currency (str):
            stake_amount (bool, date, datetime, dict, float, int, list, str, none_type):
            stake_currency_decimals (int):
            max_open_trades (int):
            minimal_roi ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            unfilledtimeout (UnfilledTimeout):
            timeframe_ms (int):
            timeframe_min (int):
            exchange (str):
            forcebuy_enabled (bool):
            ask_strategy ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            bid_strategy ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            bot_name (str):
            state (str):
            runmode (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            strategy_version (str): [optional]  # noqa: E501
            available_capital (float): [optional]  # noqa: E501
            stoploss (float): [optional]  # noqa: E501
            trailing_stop (bool): [optional]  # noqa: E501
            trailing_stop_positive (float): [optional]  # noqa: E501
            trailing_stop_positive_offset (float): [optional]  # noqa: E501
            trailing_only_offset_is_reached (bool): [optional]  # noqa: E501
            order_types (OrderTypes): [optional]  # noqa: E501
            use_custom_stoploss (bool): [optional]  # noqa: E501
            timeframe (str): [optional]  # noqa: E501
            strategy (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.version = version
        self.api_version = api_version
        self.dry_run = dry_run
        self.stake_currency = stake_currency
        self.stake_amount = stake_amount
        self.stake_currency_decimals = stake_currency_decimals
        self.max_open_trades = max_open_trades
        self.minimal_roi = minimal_roi
        self.unfilledtimeout = unfilledtimeout
        self.timeframe_ms = timeframe_ms
        self.timeframe_min = timeframe_min
        self.exchange = exchange
        self.forcebuy_enabled = forcebuy_enabled
        self.ask_strategy = ask_strategy
        self.bid_strategy = bid_strategy
        self.bot_name = bot_name
        self.state = state
        self.runmode = runmode
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, version, api_version, dry_run, stake_currency, stake_amount, stake_currency_decimals, max_open_trades, minimal_roi, unfilledtimeout, timeframe_ms, timeframe_min, exchange, forcebuy_enabled, ask_strategy, bid_strategy, bot_name, state, runmode, *args, **kwargs):  # noqa: E501
        """ShowConfig - a model defined in OpenAPI

        Args:
            version (str):
            api_version (float):
            dry_run (bool):
            stake_currency (str):
            stake_amount (bool, date, datetime, dict, float, int, list, str, none_type):
            stake_currency_decimals (int):
            max_open_trades (int):
            minimal_roi ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            unfilledtimeout (UnfilledTimeout):
            timeframe_ms (int):
            timeframe_min (int):
            exchange (str):
            forcebuy_enabled (bool):
            ask_strategy ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            bid_strategy ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            bot_name (str):
            state (str):
            runmode (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            strategy_version (str): [optional]  # noqa: E501
            available_capital (float): [optional]  # noqa: E501
            stoploss (float): [optional]  # noqa: E501
            trailing_stop (bool): [optional]  # noqa: E501
            trailing_stop_positive (float): [optional]  # noqa: E501
            trailing_stop_positive_offset (float): [optional]  # noqa: E501
            trailing_only_offset_is_reached (bool): [optional]  # noqa: E501
            order_types (OrderTypes): [optional]  # noqa: E501
            use_custom_stoploss (bool): [optional]  # noqa: E501
            timeframe (str): [optional]  # noqa: E501
            strategy (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.version = version
        self.api_version = api_version
        self.dry_run = dry_run
        self.stake_currency = stake_currency
        self.stake_amount = stake_amount
        self.stake_currency_decimals = stake_currency_decimals
        self.max_open_trades = max_open_trades
        self.minimal_roi = minimal_roi
        self.unfilledtimeout = unfilledtimeout
        self.timeframe_ms = timeframe_ms
        self.timeframe_min = timeframe_min
        self.exchange = exchange
        self.forcebuy_enabled = forcebuy_enabled
        self.ask_strategy = ask_strategy
        self.bid_strategy = bid_strategy
        self.bot_name = bot_name
        self.state = state
        self.runmode = runmode
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
